program ujs;

// Ujs disabler 1.2.1 by A.Ruzanov
// 19.06.2009

uses
  windows,
  messages,
  KOL;

const
  hlp = 'Ujs disabler v 1.2'
  +#13#13+'ujs.exe /action=exclude /script=block-external-scripts.js /url=''''%u'''''
  +#13+'ujs.exe /action=include /script=block-external-scripts.js /url=''''%u'''''
  +#13+'ujs.exe /action=toggle /script=block-external-scripts.js';

var
  UserJS, Host, UjsBak, cLine, Action: string;

function CommandLine: String;
 var P: PChar;
begin
  P := SkipSpaces( GetCommandLine );
  while P[0] > ' ' do
    if P[0] = '"' then
    begin
      Inc(P);
      while (P[0] <> #0) and (P[0] <> '"') do
        Inc(P);
      if P[0] <> #0 then Inc(P);
    end
      else
      Inc(P);
  Result := P;
end;

function GetParam(const cLine, param: String): String;
var poz, len: Integer;
    startStr, endStr: String;
begin
Result := '';
If Length(param) > 0 Then
  begin
  If (Pos('', cLine) <> 0) And (Pos('', cLine) <> 0) Then
    begin
    startStr := '/'+param+'=';
    endStr := '';
    end
  Else
    begin
    startStr := '/'+param+'=''''';
    endStr := '''''';
    end;

  poz := Pos(startStr, cLine);
  If poz = 0 Then
    begin
    startStr := '/'+param+'=';
    endStr := ' ';
    poz := Pos(startStr, cLine);
    end;
  If poz > 0 Then
    begin
    Result := Copy(cLine, poz+Length(startStr), MaxInt);
    poz := Pos(endStr, Result);
    If poz > 0 Then SetLength(Result, poz-1);
    len := Length(Result);
    If (len >= 2) And (Result[1]='"') And (Result[len]='"') Then Result := Copy(Result, 2, len-2);
    end;
  end;
end;

function HostName(const Str: string): string;
var P: Integer;
    protocol, host: string;
begin
  Result := '';
  P := Pos('://', Str);
  If P <> 0 Then
    begin
    protocol := Copy(Str, 1, P);
    host := Copy(Str, P+3, MaxInt);
    P := Pos('/', host);
    If P <> 0 Then SetLength(host, P);
    Result := protocol + '//' + host;
    end
end;

function TopDir: String;
begin
Result := ExcludeTrailingPathDelimiter(GetStartDir);
DeleteTail(Result, Length(Result)-DelimiterLast(Result, '\'));
Result := ExcludeTrailingPathDelimiter(Result);
end;

function UjsPath(NameDir: String): String;
var
  ODefIni, O6Ini: pIniFile;
  PathO6, oDef6Path, o6Name, AppDataPath: string;
  MultiUser, isOpera10: Boolean;
  K: HKEY;
begin
Result := '';

isOpera10 := FileExists(NameDir + '\operaprefs_default.ini');
If isOpera10 Then
  begin
  o6Name := 'operaprefs.ini';
  oDef6Path := NameDir + '\operaprefs_default.ini';
  end
Else
  begin
  o6Name := 'opera6.ini';
  oDef6Path := NameDir + '\operadef6.ini';
  end;

ODefIni := OpenIniFile(oDef6Path);
ODefIni.Mode := ifmRead;
ODefIni.Section := 'System';
MultiUser := ODefIni.ValueBoolean('Multi User', True);
ODefIni.Free;

If Not MultiUser Then
  PathO6 := NameDir + '\profile\' + o6Name
Else
  begin
    K := RegKeyOpenRead(HKEY_CURRENT_USER, 'SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders');
    AppDataPath := RegKeyGetStr(K, 'AppData');
    RegKeyClose(K);
    NameDir := CopyEnd(NameDir, DelimiterLast(NameDir, '\')+1);
    PathO6 := IncludeTrailingPathDelimiter(AppDataPath + '\opera\' + NameDir);
    If isOpera10 Then PathO6 := PathO6+o6Name Else PathO6 := PathO6+'profile\'+o6Name;
  end;

If Not FileExists(PathO6) Then Exit;

O6Ini := OpenIniFile(PathO6);
O6Ini.Mode := ifmRead;
O6Ini.Section := 'User Prefs';
Result := IncludeTrailingPathDelimiter(Utf8ToAnsi(O6Ini.ValueString('User JavaScript File', '')));
O6Ini.Free;
end;

procedure ExInc(UserJS, Host: String; exclude: Boolean);
const
  h = '// ==UserScript==';
  e = '// ==/UserScript==';
  inc = '// @include ';
  exc = '// @exclude ';
var
  addstr, antistr, str, ret: String;

begin
str := StrLoadFromFile(UserJS);
If Pos(#13#10, str) <> 0 Then ret := #13#10 Else ret := #10;

StrReplace(Host, 'http://www.', 'http://*');
If exclude Then
  begin
  addstr := exc+Host+'*'+ret;
  antistr := inc+Host+'*'+ret;
  end
Else
  begin
  addstr := inc+Host+'*'+ret;
  antistr := exc+Host+'*'+ret;
  end;

If Pos(addstr, str) = 0 Then
  begin
  If (Pos(h, str) <> 0) And (Pos(e, str) <> 0) Then
    begin
    If Pos(antistr, str) <> 0 Then
      StrReplace(str, antistr, addstr)
    Else
      StrReplace(str, e, addstr+e);
    end
  Else If MessageBox(0, PChar('File does not exist: '+UserJS+'!' + #13 + 'Are you sure what want to continue?'), nil, 49) = 1 Then str := h+ret+addstr+e+ret+ret+str;

  If str <> '' Then StrSaveToFile(UserJS, str);
  end;
end;


begin
If ParamCount = 0 Then
  begin
  MessageBox( 0, PChar(hlp), PChar('About'),  262208 );
  Exit;
  end;

cLine := CommandLine;
Action := GetParam(cLine, 'action');
UserJS := UjsPath(TopDir)+GetParam(cLine, 'script');
Host := HostName(GetParam(cLine, 'url'));
UjsBak := UserJS+'.xx';

If Action = 'toggle' Then
  begin
  If FileExists(UserJS) And Not FileExists(UjsBak) Then
    MoveFile(PChar(UserJS), PChar(UjsBak))
  Else
    If FileExists(UjsBak) And Not FileExists(UserJS) Then
      MoveFile(PChar(UjsBak), PChar(UserJS));
  end;

If Action = 'exclude' Then  ExInc(UserJS, Host, true);
If Action = 'include' Then ExInc(UserJS, Host, false);

end.

